#CLgraphgen.py written for Python 2.7
#
#DG 
#
# build a random undirected graph and the ILP formulation to find a maximum clique in it.
# Also, output the adjacency matrix of the graph.
#
# Call the program on a command line  in a terminal window. Use:
# python CLgraphgen.py
#
# DG October 5, 2017
#
import random

def main():
    OUTLP = open("clique.lp", 'w')
    OUTGRAPH = open("graph", 'w')
    nodenum = raw_input("How many nodes in the graph?  ")
    prob = raw_input("What edge probability?  ")
    nodenum = int (nodenum)
    fprob = float (prob)

    print "You input: %d, %f" % (nodenum,  fprob)
    rcut = fprob * 100

    OUTLP.write("Maximize\n")

    objective = ""
    constraints = ""
    bvars = ""
    nodenump1 = int(nodenum) + 1
    
    matrix = []
    for i in range (0, nodenump1):
        matrix.append(['0']*nodenump1)


    for i in range(1, nodenump1):
        objective = objective + "+ C(%d) " % i
        bvars = bvars + "C(%d)\n" % i

    for i in range (1, nodenump1 - 1): 
        for j in range (i+1, nodenump1): 
            randomnum = random.randrange(101) # pick a random integer between 0 and 100
#            print "The random number is", randomnum

            if (randomnum  < rcut):   # if the random number is less than the 
                                      # cutoff, rcut, then there is an edge between
                                      # nodes i and j. Otherwise there is no edge between i and j, and hence
                                      # we add the constraint to the concrete ILP formulation 
                                      # that says that at most one of i and j can be
                                      # selected.
#               print "%d, %d" % (i, j)
               matrix[i][j] = '1'
               matrix[j][i] = '1'
            else:
               constraints = constraints + "C(%d) + C(%d) <= 1\n" % (i,j)
    
   

    OUTLP.write(objective + "\n")
    OUTLP.write ("subject to \n")
    OUTLP.write(constraints + "binary \n")
    OUTLP.write(bvars + "\n")
    OUTLP.write("end")

    for i in range(1,nodenump1):
        for j in range(1,nodenump1):
            OUTGRAPH.write(matrix[i][j])
        OUTGRAPH.write("\n")
    print "\n The ILP formulation is in file %s, and the graph adjacency matrix is in file %s \n " % ('clique.lp', 'graph')

main()
