# LCS.pl
#!/usr/bin/perl

# This program uses dynamic programming to compute the LCS of two strings. 
# DG
#
# call on a command line as:
# perl LCS.pl file-name
#
# the file should have two sequences written over the alphabet A,T,C,G, written on two lines
#
open (IN, $ARGV[0]);  # file name
open (OUT, ">LCS$ARGV[0]");      

$line1 = <IN>;
chomp $line1;
print "The first sequence is  $line1 \n";

$line2 = <IN>;
chomp $line2;
print "The second sequence is $line2 \n";

@string1 = split(//, $line1);
@string2 = split(//, $line2);

#print "@string1  @string2\n";

$n = @string1;                                              
$m = @string2;

print "The lengths of the two strings are $n, $m \n";

$Vm = 1;
$Cm = 0;
$Im = 0;

$V[0][0] = 0;

for ($i = 1; $i <= $n; $i++) {
        $V[$i][0] = -$i;
        print OUT "$string1[$i-1]";
}

print OUT "\n";

for ($j = 1; $j <= $m; $j++) {
        $V[0][$j] = -$j;
        print OUT "$string2[$j-1]";
}

print OUT "\n";

for ($i = 1; $i <= $n; $i++) {
    for ($j = 1; $j <= $m; $j++) {
        	
        if ($string1[$i-1] eq $string2[$j-1]) {
        	$t = 1*$Vm;
        }
                
        else {
        	$t = 1*$Cm;
        }

        $max = $V[$i-1][$j-1] + $t;

        if ($max < $V[$i][$j-1]) {
            $max = $V[$i][$j-1] + (1 * $Im);
        }

        if ($V[$i-1][$j] > $max) {
        	$max = $V[$i-1][$j] + (1 * $Im);
        }

        $V[$i][$j] = $max;
        print OUT "\nV[$i][$j] has value $V[$i][$j]";

    }
}

print "\n";
print "\n The length of the LCS is:  $V[$n][$m]\n";
print OUT "\n The length of the LCS is:  $V[$n][$m]\n";
close(OUT);
