# denseILP.pl
# builds a random graph and then finds the largest subgraph that has the required density or greater.
# Feb. 6, 2016
#
print "How many nodes in the graph?  ";
$nodenum = <>;
print "What edge probability?  ";
$rcut = <>;
print "What density? "; # a number between 0 and 1
$percent = <>;
chomp $percent;
open (OUT, '>out.lp');

print OUT "Maximize\n";

$objective = "";
$constraints = "";
$potentials = "";
$edges = "";

$binaries = "";
foreach $i (1 .. $nodenum) {
  $objective .=  "+ C$i ";
  $binaries .= "C$i\n";
}

foreach $i (1 .. $nodenum - 1) {
  foreach $j ($i+1 .. $nodenum) {
   
    $constraints .= "C$i + C$j - P$i,$j <= 1\n";  # this records that there is a potential edge 
                                                  # between $i and $j, if both $i and $j are chosen.
    $potentials .= "- $percent P$i,$j ";

    $binaries .= "C$i\nC$j\n";
    $binaries .= "P$i,$j\n";

    $randomnum = rand(1);
    print "$randomnum  ";
    if ($randomnum  < $rcut) { # when this holds, there is an edge in the graph between $i and $j
      $constraints .= "2 E$i,$j - C$i - C$j <= 0\n";  # this says that if E$i,$j is set to 1, there must be an edge
                                                    # between $i and $j, and both those nodes have been chosen.
      $edges .= "+ E$i,$j ";
      $binaries .= "E$i,$j\n";
    }
   }
}

print OUT "$objective \n";
print OUT "subject to \n";
print OUT "$constraints \n"; 
print OUT "$edges \n $potentials >= 0 \n";
print OUT "binary\n";
print OUT "$binaries";
close OUT;

