# denseILP.pl
# creates the ILP formulation to find a densest subgraph in an input graph

open (IN, $ARGV[0]);
open (OUT, ">$ARGV[0].lp");
$density = $ARGV[1]; # a number between 0 and 1

print OUT "Maximize\n";

$objective = "";
$constraints = "";
$binaries = "";
$nodenum = 0;

$potentials = "";
$edges = "";
$binaries = "";

$i = 1;
while ($line = <IN>) {
   chomp $line;
   $nodenum = length($line);
   @chars = split (//, $line);

   $objective .=  "+ C$i ";
   $binaries .= "C$i\n";

  foreach $j ($i+1 .. $nodenum) {
   
    $constraints .= "C$i + C$j - P$i,$j <= 1\n";  # this records that there is a potential edge 
                                                  # between $i and $j, if both $i and $j are chosen.
    $potentials .= "- $density P$i,$j ";

    $binaries .= "C$i\nC$j\n";
    $binaries .= "P$i,$j\n";

    if ($chars[$j-1] eq 1 ) { # when this holds, there is an edge in the graph between nodes $i and $j
      $constraints .= "2 E$i,$j - C$i - C$j <= 0\n";  # this says that if E$i,$j is set to 1, there must be an edge
                                                    # between $i and $j, and both those nodes have been chosen.
      $edges .= "+ E$i,$j ";
      $binaries .= "E$i,$j\n";
    }
   }
$i++;
} # end while

print OUT "$objective \n";
print OUT "subject to \n";
print OUT "$constraints \n"; 
print OUT "$edges \n $potentials >= 0 \n";
print OUT "binary\n";
print OUT "$binaries";
close OUT;

