# kpart4.py written for Python 2.7
# DG this looks like it was superseaded by kcutf.py which allows any number of features, although
# it doesn't have the n/7 constraint for the size of each class in the partition.

#DG but kcutf.py must assign a node (or more) to each function ahead of time.

# Call with arguments graphfile, featurefile, ilpfile, number of nodes
#
# This Python program reads a file describing a graph, 
# and then it creates the concrete ILP to partition the nodes into four subsets, where each has
# size at least n/7, minimizing the number of edges that cross between subsets.
# November 30, 2017
# November 26, 2017
# DG October 18, 2017


import sys  # this imports the module called `sys', which is a collection of programs
            # that facilitate system calls

graph = sys.argv[1]    # assign the first argument to the variable arg1
features = sys.argv[2]    # assign the second argument to the variable arg2
                      # The values in arg1 and arg2 are strings.

ilp = sys.argv[3] # the name of the output ilp file

objective = ""
constraints = ""
binaries = ""

INGRAPH = open(graph, "r")  # open the file specified by the value of arg1, to read from the file.
INFEATURES = open(features, "r") # open the file specified by the value of arg2, to read the features from a file
OUTILP = open(ilp, "w")

n = sys.argv[4]  # the number of nodes in the input graph
n = int(n)

np1 = n+1
edgecount = 0

# in the next block, we read in the nodes that have features, and what the features are.

for line in INFEATURES:
      print (line)
      (s,f) = line.split()
      s = int(s)    
      f = int(f)
      print "%d %d" % (s,f)
      constraints = constraints + "X(%d,%d) = 1 \n" % (s, f) # X(s, f) # records that node i has feature f
      binaries = binaries + "X(%d,%d) \n" % (s, f)

i = 0
for line in INGRAPH:
     i = i + 1
#     for f in (1,2,3,4):
     for f in (1,2):
         constraints = constraints + "+ X(%d,%d) " % (i,f)  # set up equality to ensure that node i is assigned a feature during
                                                            # the ILP execution.
         binaries = binaries + "X(%d,%d) \n" % (i, f)

     constraints = constraints + "= 1 \n"                   # these constraints are redundant for the nodes that were 
                                                            # assigned a feature from INFEATURES, but Gurobi preprocesser will
                                                            # sort that out.

     j = 0
     for char in line:
         j = j + 1
         if (j > i):
           if (char == '1'):                 # (i,j) is an edge
                  edgecount = edgecount + 1 
                  objective = objective + "+ Z(%d,%d) " % (i,j)
                  binaries = binaries + "Z(%d,%d) \n" % (i,j)
                  for f in (1,2,3,4):
                      constraints = constraints + "Z(%d,%d) + X(%d,%d) - X(%d,%d) >= 0 \n" % (i,j,i,f,j,f)
                      constraints = constraints + "Z(%d,%d) - X(%d,%d) + X(%d,%d) >= 0 \n" % (i,j,i,f,j,f)

OUTILP.write ("Minimize\n")
OUTILP.write (objective + "\n")
OUTILP.write ("such that \n\n")

#for f in (1,2,3,4):
for f in (1,2):
   part = ""
   for i in range(1,np1):
       part = part + "+ X(%d,%d) " % (i,f)
       print part + "\n"
   bound = n/7
   print bound
   part = part + ">= %d \n" % bound
   OUTILP.write (part)

OUTILP.write(constraints)
OUTILP.write("\nbinary \n")
OUTILP.write(binaries)
print "The number of edges is %d \n" % edgecount
