# pmarkersolcheck.pl 
# updated Jan. 15, 2018
# August 17, 2017
#
# process the cX.sol file to extract the TSP solution permutation and then rearrange the cols.
# This variant is for use when the columns of the original data were permuted, to break up
# the intervals of consecutive ones.  This program is called inside of marker-pipeline.pl

open (SOL, "$ARGV[0]");  # the solution file
open (PSOL, ">p$ARGV[0]"); # the outputfile
$sites = $ARGV[1];
open (DATA, "$ARGV[2]"); # this is the original data before permutation 
open (PDATA, "$ARGV[3]"); # this is the permuted data before the TSP solution
print "No. sites = $sites \n";
@lines = <SOL>;
%perm = ();


#print PSOL "node1 node2 quantity\n";
foreach $line (@lines) {
#  print "$line";
  if ($line =~ /f(\d+),(\d+) (\d+)/) {
#     print PSOL "$1, $2, $3 \n";

  $quant = $3;
  $position = $sites + 2 - $quant; # change Jan. 14, 2018
#     $position = $sites + 1 - $quant;
#     print PSOL "position: $quant --> $position\n";
     $perm{"$position"} =  $2; # replace with the line below to use the original permutation
                                # rather than its reverse
#     $perm{"$quant"} =  $2;
  }
}

#print PSOL "i   perm{i} \n";

#foreach $i (sort {$a <=> $b} keys %perm) {
# print PSOL "node $perm{$i} (which is originally one smaller) is in position $i of the TSP \n";
#}

#print "\n";
@solution = ();

@data = ();
print PSOL "The permuted data\n";

$i = 1;   

while ($line = <PDATA>) {  # This is the permuted data before the ILP creation programs
                           # MgraphTSPfile.pl or M1graphTSPfile.pl add a new node.
    print PSOL "$line";
    chomp $line;
    $lenindex = length($line) - 1; # this is the largest column index into linedata
    @linedata = split (//, $line);
       foreach $j (0 .. $lenindex) {  
             $data[$i][$j+1] = $linedata[$j];  # this is the data input to the ILP for solution
       }
    $i++;
}
$n = $i - 1; # this is largest row index needed into data.

print PSOL "sites $sites, n $n \n";

foreach $k (1 .. $sites) {  # arrange the cols. according to the TSP solution
      $j = $perm{"$k"} - 1; # changed Jan. 15, 2018
      foreach $i (1 .. $n) {
#         print PSOL "DDD $k, $j, $i, $data[$i][$j] \n";
         $solution[$i][$k] = $data[$i][$j];
      }
}

$totalerror = 0;
print PSOL "\n The solution obtained from the TS computation \n";

foreach $i (1 .. $n) {
   foreach $j (1 .. $sites) {
      print PSOL "$solution[$i][$j]";
   }
   print PSOL "\n";
}

@origdata = <DATA>;
print PSOL "\nThe line-by-line comparison - each row is shown, and then the solution.\n";
print PSOL "The reverse solution is also shown if the first solution has an error. \n\n";

foreach $i (1 .. $n) {
   print PSOL "$origdata[$i-1]";  # the generated data in intervals

#   foreach $j (1 .. $sites) {
#      print PSOL "$data[$i][$j]";  # the data as input to the column-permutation problem
#   }
#   print PSOL "\n";

   @line = (); 
   $error = 0;
   foreach $j (1 .. $sites) {    # the solution implied by the TSP
      print PSOL "$solution[$i][$j]";
      @line = split (//, $origdata[$i-1]);
      if ($line[$j-1] != $solution[$i][$j]) {
          $error++;
      }
   }
   print PSOL "  Error = $error"; # this gives the error in each line
   print PSOL "\n";

if ($error == 0) {
    print PSOL "Perfect re-creation \n";
}
   
#   if ($error > 0) {
else {
       $error = 0;
       for  ($j = $sites; $j > 0 ; $j--) { # the reverse of the solution implied by the TSP
          print PSOL "$solution[$i][$j]";
          $rj = $sites - $j;
          if ($line[$rj] != $solution[$i][$j]) {
              $error++;
          }
        }
   print PSOL "  Error = $error"; # this gives the error in each line
   if ($error == 0) {
       print PSOL "\nPerfect re-creation \n";
   }
}
  print PSOL "\n\n";

#$totalerror += $error; # this accumulates the error over all of the lines
}

#print PSOL "Total error = $totalerror \n";

print "The output is in file p$ARGV[0] \n";



