#randomgraph.pl
# Aug. 6, 2017
#
# build a random undirected, edge-weighted graph and output the edge-weight matrix to a file.
# Execute on a command line in a terminal window::
#
# perl randomgraph.pl outfile-name number-of-nodes edge-probability
#
# DG May 27, 2016
#
$outfile = $ARGV[0];
open (OUT, ">$outfile");

$nodenum = $ARGV[1];

#print "How many nodes in the graph?  ";
#%$nodenum = <>;

$rcut = $ARGV[2];

#print "What edge probability?  ";
#$rcut = <>;

print "$outfile, $nodenum, $rcut \n";

@D = ();

foreach $i (1 .. $nodenum-1) {
  foreach $j ($i .. $nodenum) {
   
    if ($i == $j) {
      $D[$i][$j] = 0;
    }
    else {
       $randomnum = rand(1);
#       print "$randomnum  ";

       if ($randomnum  < $rcut) { # if the random number is less than the cutoff, then there is an edge between
                                  # nodes i and j. Otherwise there is no edge between i and j. 
           $randdist = int rand(100);
#           print "$i, $j, $randdist\n";
           $D[$i][$j] = $randdist;
           $D[$j][$i] = $randdist;

         }
         else {
            $D[$i][$j] = 200;
            $D[$j][$i] = 200;
          }
      }
   }
}
 
$D[$nodenum][$nodenum] = 0;

foreach $i (1 .. $nodenum) {
  foreach $j (1 .. $nodenum) {
    print OUT "$D[$i][$j] ";
  }
  print OUT "\n";
}

print "The edge-weight matrix is in file $outfile \n";
close OUT;

