#spersistent.pl
#
# Dan Gusfield August 14, 2018

# This script takes in a binary matrix M and executes three Perl programs that together
# create the concrete ILP formulation to solve the persistent-phylogeny problem on the
# input.
# The three programs are: 
# 1. sperfreduce.pl which removes any column in M that is compatible with all other
# columns. It also removes any duplicate rows. These removals make final concrete ILP 
# solve much faster.
# 2. sprepare-persistent.pl which creates the extended matrix M' from M
# 3. persistent.pl which creates the concrete ILP from M'

# On a command line, call the program as:
# perl sperfreduce.pl data-file 

# The ILP formulation is output to the file called `persistent.lp'

$input = $ARGV[0];

system ("perl sperfreduce.pl $input"); # create the reduced matrix from M, put the result in file "r$input"
system ("perl sprepare-persistent.pl r$input"); # create the extended matrix M'. the result will be in file "pr$input"

system ("perl persistent.pl pr$input");

