# sprepare-persistent.pl
# updated August 8, 2018

# DG
#
# This processes a binary matrix, read from a file, to create the file containing the extended matrix with 2s (representing ?s)
# used next, by persistent.pl, to create ILPs to test for a persistent phylogeny.
#
# call on a command line in a terminal window as:
# perl sprepare_persistent.pl data-file
#
# The data-file can hold any binary matrix. However, if the binary matrix has first been passed through sperfreduce.pl, then
# it will be smaller, and the ultimate concrete ILP formulation will be smaller and will solve faster. So, it is recommended
# that the data-file be one that is the output of sperfreduce.pl.
#
# Example data: rper-data which is the output of sperfreduce.pl with input per-data
#

$hfile = "$ARGV[0]"; 

  open HFILE, "$hfile";
  open PFILE, ">p$hfile";

  @lines = <HFILE>;
  close HFILE;

  $line = $lines[1];
  chomp $line;
  $line =~ tr/ //d;
  $stringlen = length ($line);
#  print "stringlen $stringlen \n";

   foreach $line (@lines) {
     chomp $line;
     @chars = split(/ /, $line);
     $length = @chars;
     if ($length == 1) { # this is to handle the case that there are no spaces between characters in the input.
        @chars = split (//, $line);
        $length = @chars;
     }

     foreach $i (0...$length -1) {
       if ($chars[$i] eq 0) {
          print PFILE "22";
       }
       if ($chars[$i] eq 1) {
          print PFILE "10";
       }
     }
     print PFILE "\n";
   }
  $newstring = "0"x(2 * $stringlen);
  print PFILE "$newstring\n";  # this adds a row that is all-zeros (not converted to ?s). That will force any ILP solutions
                              # to have an all-zero taxon. Without that, the ILP solution might change the ?s to create a persistent phylogeny
                              # rooted at a string that is not the all-zero string, even if no pp exists with the all-zero root. 
                
print "The extended matrix is in file p$hfile \n";
close PFILE;
